#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "Fish_SeniorItemExchangeCFG.h"
#include "FileEncrypt.h"
std::auto_ptr<Fish_SeniorItemExchangeCFG> Fish_SeniorItemExchangeCFG::msSingleton(nullptr);

int Fish_SeniorItemExchangeCFG::GetCount()
{
	return (int)mMapData.size();
}

const Fish_SeniorItemExchangeCFGData* Fish_SeniorItemExchangeCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<int, Fish_SeniorItemExchangeCFGData>& Fish_SeniorItemExchangeCFG::GetMapData()
{
	return mMapData;
}

void Fish_SeniorItemExchangeCFG::Reload()
{
	mMapData.clear();
	Load();
}

void Fish_SeniorItemExchangeCFG::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Fish_SeniorItemExchangeCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mType = element->IntAttribute("Type");
		{
			const char* ItemId = element->Attribute("ItemId");
			std::vector<std::string> vecItemId;
			boost::split(vecItemId, ItemId, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecItemId.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecItemId[i].c_str(), &temp))
				{
					data.mItemId.push_back(temp);
				}
			}
		}
		{
			const char* ItemCount = element->Attribute("ItemCount");
			std::vector<std::string> vecItemCount;
			boost::split(vecItemCount, ItemCount, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecItemCount.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecItemCount[i].c_str(), &temp))
				{
					data.mItemCount.push_back(temp);
				}
			}
		}
		{
			const char* ExchangeItemId = element->Attribute("ExchangeItemId");
			std::vector<std::string> vecExchangeItemId;
			boost::split(vecExchangeItemId, ExchangeItemId, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecExchangeItemId.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecExchangeItemId[i].c_str(), &temp))
				{
					data.mExchangeItemId.push_back(temp);
				}
			}
		}
		{
			const char* ExchangeItemCount = element->Attribute("ExchangeItemCount");
			std::vector<std::string> vecExchangeItemCount;
			boost::split(vecExchangeItemCount, ExchangeItemCount, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecExchangeItemCount.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecExchangeItemCount[i].c_str(), &temp))
				{
					data.mExchangeItemCount.push_back(temp);
				}
			}
		}
		{
			const char* ExchangeItemWeight = element->Attribute("ExchangeItemWeight");
			std::vector<std::string> vecExchangeItemWeight;
			boost::split(vecExchangeItemWeight, ExchangeItemWeight, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecExchangeItemWeight.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecExchangeItemWeight[i].c_str(), &temp))
				{
					data.mExchangeItemWeight.push_back(temp);
				}
			}
		}
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		assert(mMapData.find(data.mID) == mMapData.end());
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
}

void Fish_SeniorItemExchangeCFG::Load()
{
	Load("../Config/Fish_SeniorItemExchangeCFG.xml");
}

Fish_SeniorItemExchangeCFG* Fish_SeniorItemExchangeCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Fish_SeniorItemExchangeCFG());
	}
	return msSingleton.get();
}
